;;
;; Estructura de entidad
;;
.macro DefineCmp_Entity _x, _y, _vx, _vy, _w, _h, _pspr_l, _pspr_r, _aist, _patrol
	.db _x, _y ;; Posicion
	.db _vx, _vy ;; Velocidad
	.db _w, _h ;; Tamaño
	.dw _pspr_l ;; Puntero a Sprite izquierda
	.dw _pspr_r ;; Puntero a Sprite derecha
	.db 0x00, 0x00 ;; AI-aim (ai_aim_x, ai_aim_y) --> Objetivo donde voy
	.db _aist ;; AI-status (ai_st) --> Estado actual de la iA
	.dw _x, _y ;; Ultimo valor de la Memoria de video donde he estado
	.db _aist;15
	.dw 0x0000;16,17
	.db _patrol

.endm


;; Entity_t offsets
e_x 			= 0 		;; Posicion x
e_y 			= 1 		;; Posicion y
e_vx 			= 2 		;; Velocidad x
e_vy 			= 3 		;; Velocidad y
e_w 			= 4 		;; Ancho
e_h 			= 5 		;; Alto
e_pspr_l_left 	= 6 		;; Puntero a sprite mirando izquierda
e_pspr_h_left 	= 7 		;; Puntero a sprite mirando izquierda
e_pspr_l_right 	= 8 		;; Puntero a sprite mirando derecha
e_pspr_h_right 	= 9 		;; Puntero a sprite mirando derecha
e_ai_aim_x 		= 10 		;; Posicion donde ir con IA
e_ai_aim_y 		= 11 		;; Posicion donde ir con IA
e_ai_st 		= 12 		;; Estado actual de la IA
e_lastVP_l 		= 13 		;; last video memory poi nter l
e_lastVP_h 		= 14 		;; las video memory pinter h
e_ai_last_st	= 15 		;;Ultimo estado 
e_ai_patrol_step_l= 16 	;;Array del patrol
e_ai_patrol_step_h= 17 	;;Array del patrol
e_jump      	= 18 		;; etity jump
e_patrol_number 	= 19 	;; Patrulla que tengo que asignar
e_last_movement 	= 20	;; Ultimo moovimiento para saber que sprite pintar (0 --> izquierda, 1 --> derecha)
sizeof_e		= 21 		;; Tamaño para calcular el salto a la proxima entidad

;; Entity_T AI-status enum
e_ai_st_noAI = 0 		;; No tiene IA
e_ai_st_stand_by = 1 	;; Mantenerse parado
e_ai_st_move_to = 2 	;; Moverse a
e_ai_st_patrol = 3 	;; Moverse a
e_ai_door = 4 		;; La entidad es una puerta
e_ai_last_door = 5 	;; La entidad es la ultima puerta del juego


jumptable:
	.db #-4, #-4, #-4, #-4;SUBIDA
	.db #-4, #-4, #-4, #-4;SUBIDA
	;.db #-2, #-2, #-2, #-2;SUBIDA
	;.db #-1, #-1, #-1, #-1;SUBIDA
	
	.db #00, #00, #00, #00

	.db #2, #2, #2, #2;SUBIDA
	.db #4, #4, #4, #4;BAJADA

	.db #0x80 ;; Marco el final con un byte --> -128

;; Constructor por defecto de Entity Components
.macro DefineCmp_Entity_default
	DefineCmp_Entity 0, 0, 0, 0, 1, 1, 0x0000, 0x0000, e_ai_st_noAI, 0
.endm


;; Array of Entity Components
.macro DefineCmpArray_Entity _N
	.rept _N
		DefineCmp_Entity_default
	.endm
.endm