;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/game.h.s"

.module main

.area _DATA

;; string: .asciz "CPCtelera up and running!";

.area _CODE


;; Musica del juego
;; Interrupt Service Rutin
variable: .db #06 ;; Sirve para llamar 1 de cada 12 interrupciones a la musica (1 vez cada 2 fotogramas)
isr:

   ex af, af'
   exx
   push af
   push bc
   push de
   push hl
   push iy
   
   ld a, (variable)
   dec a
   ld (variable), a
   jr nz, return

      call cpct_akp_musicPlay_asm
      ld a, #06
      ld (variable), a

   return:
   pop iy
   pop hl
   pop de
   pop bc
   pop af
   exx   
   ex af, af'

   ret


;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm

   ;; INIT Music
   ld de, #_game_song
   call cpct_akp_musicInit_asm
   ;; Set ISR
   ld hl, #isr
   call cpct_setInterruptHandler_asm


_main2::
   ;; INIT Game Manager
   call man_game_init

;, Loop infinito
loop:
   call man_game_update
   
   cp #_end_game 			;; Compruebo si se ha terminado el juego debido a una colision
   jr z, _main_dead			;; Si se ha terminado lo reseteo
   
   
   ;; TO-DO METER EL GAME-OVER


   cp #_end_game_door
   call z, _main2

   cp #_end_game_last_door
   call z, _main_reset

   ;; waitNSyncs 2
   call cpct_waitVSYNC_asm
   call man_game_render

   jr loop


_main_dead::
   ld hl, #_level_counter
   ld (hl), #0
   call dead_screen
   jr _main2

_main_reset::
   call victorius_screen
   jr _main2


;_main_next_level::
;   ;; Disable firmware to prevent it from interfering with string drawing
;   call cpct_disableFirmware_asm
;   ;; INIT Game Manager
;   call man_game_init_door
;
;;, Loop infinito
;loop_door:
;   call man_game_update
;   
;   cp #_end_game        ;; Compruebo si se ha terminado el juego debido a una colision
;   call z, _main        ;; Si se ha terminado lo reseteo
;
;   cp #_end_game_door
;   call z, _main_next_level
;
;   ;; waitNSyncs 2
;   call cpct_waitVSYNC_asm
;   call man_game_render
;
;   jr loop_door