;;
;; INPUT SYSTEMS
;;
.include "cpctelera.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "cpct_functions.h.s"


;; Inicializacion
sys_input_init::
	ld (_ent_array_ptr_input), hl
	ret


;; Actualizacion sistema input --> Actualiza la entidad 0 (player) del vector de entidades
sys_input_update::
_ent_array_ptr_input = . + 2 ;; Constante que apunta al array de entidades
	;; Sobreescribo el valor #0x0000 con el puntero al array de entidades
	ld ix, #0x0000 ;; La instruccion ocupa 4 bytes, 2 para ld ix y 2 para #0x0000
	
	;; Modifico la velocidad a 0 (paro al jugador)
	ld e_vx(ix), #0
	ld e_vy(ix), #0

	;; Escaneo el teclado
	call cpct_scanKeyboard_f_asm


	;; Si alguien ha pulsado la O (moverse ixquierda)
	ld hl, #Key_O
	call cpct_isKeyPressed_asm
	jr z, O_NotPressed

O_Pressed:
	ld e_vx(ix), #-1
	ld e_last_movement(ix), #00

O_NotPressed:
	ld hl, #Key_P
	call cpct_isKeyPressed_asm
	jr z, P_NotPressed

P_Pressed:
	ld e_vx(ix), #1
	ld e_last_movement(ix), #01

P_NotPressed:
	ld hl, #Key_Q
	call cpct_isKeyPressed_asm
	jr z, Q_NotPressed

Q_Pressed:
	call sys_jump_init

Q_NotPressed:
	ld hl, #Key_A
	call cpct_isKeyPressed_asm
	jr z, A_NotPressed

A_Pressed:
	ld e_vy(ix), #2

A_NotPressed:

	ld e_ai_aim_x(ix), #0
	ld hl, #Key_Space
	call cpct_isKeyPressed_asm
	jr z, Spc_NotPressed

Spc_Pressed:
	ld e_ai_aim_x(ix), #1

Spc_NotPressed:
	ret