;;
;; JUMP SYSTEM
;;
.include "cpctelera.h.s"
;;.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "cpct_functions.h.s"


sys_jump_init::
	ld a, e_jump(ix)
	cp #-1 ;; Si A == -1 activa al flag Z --> No esta saltando
	call z, sys_jump_start ;; Voy a sys_jump_start si el valor es #-1

	;cp #-2
	;call z, sys_jump_end

	ret


sys_jump_start::
	ld a, #0
	ld e_jump(ix), a

	ret

sys_jump_update::
	ld a, e_jump(ix)
	cp #-1
	jr z, sys_jump_end
	;; Entity Move --> Get jump value
	;; Cojo la direccion base de array y le voy sumando la direccion del indice
	ld hl, #jumptable ;; Cargo en hl la posicion donde empieza la tabla de saltos
	ld c, a
	ld b, #0
	add hl, bc ;; HL += BC

	;; Check End of Jump Table
	ld a, (hl)
	cp #0x80
	jr z, sys_jump_end

	;; Do Jump Movement
	ld b, a ;; B = Jump Movement
	ld a, e_vy(ix) ;; A = e_vy(ix)
	add b ;; A += B
	ld e_vy(ix), a ;; Actualizo la nueva velocidad de la entidad

	;; Increment entity jump Index
	ld a, e_jump(ix)
	inc a
	ld e_jump(ix), a ;; Actualizo el indice del jumptable

	ret

sys_jump_end::
	ld a, #-1
	ld e_jump(ix), a

	ret