;;
;; ENTITY PHYSICS MOVEMENTS
;; Mueve las entidades en funcion de la velocidad
;;
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"

.module sys_entity_pysics

;; Constantes alto y ancho de pantalla
screen_width = 80
screen_height = 200


;; Inicializacion sistema de render
sys_physics_init::
	ld (_ent_array_ptr_physics), hl
	ret

vy_negativa:

	ld a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	;En A la Y actualizada para saber la posicion final (la x ya se ha actualizado en el paso anterior)

	;ESQUINA SUPERIOR IZQUIERDA
	ld    c, e_x(ix) ;LA X ya actualizada en la fase de Physics.x
	ld    b, a 	     ;B = y+vy (calculada en a despues de endif_x)
	ld    de, #0xC000
	call cpct_getScreenPtr_asm
	jr obstaculo_y_UP

vy_positiva:

	ld a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #15
	;add #8; A = vy+y+h 

	ld    c, e_x(ix) ;LA X ya actualizada en la fase de Physics.x
	ld    b, a 	     ;B = y+vy ()
	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w
	jr obstaculo_y_DOWN

vyNeutra:

	ld a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #16
	;add #8; A = vy+y+h 

	ld    c, e_x(ix) ;LA X ya actualizada en la fase de Physics.x
	ld    b, a 	     ;B = y+vy ()
	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w
	jr obstaculo_y_DOWN

obstaculo_y_UP:

	ld a, (hl)
	cp #0x03  ;;Mis tiles de color de fondo
	jp nz, gravedadUP


	;CENTRO SUPERIOR
	inc hl
	inc hl
	;El sprite tiene 8 pixeles de ancho (4 Bytes)
	;-->HL pos x+2, y(2 para ir al punto medio del sprite (parte superior))
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, gravedadUP

	;ESQUINA SUPERIOR DERECHA
	inc hl
	;inc hl
	;-->HL pos x+4 ,y (4 porque arriba ya hemos incrementado hl en 2 )
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, gravedadUP

	jp valid_y

obstaculo_y_DOWN:

	ld a, (hl)
	cp #0x03  ;;Mis tiles de color de fondo
	jp nz, invalid_y_down

	inc hl
	inc hl
	;El sprite tiene 8 pixeles de ancho (4 Bytes)
	;-->HL pos x+2, y(2 para ir al punto medio del sprite (parte superior))
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, invalid_y_down

	;ESQUINA SUPERIOR DERECHA
	inc hl
	;inc hl
	;-->HL pos x+4 ,y (4 porque arriba ya hemos incrementado hl en 2 )q
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, invalid_y_down

	jp gravedad; NO TENEMOS NINGUN OBSTACULO DEBAJO (DEBEMOS CAER)


gravedadUP:

	ld e_jump(ix), #16
	jp invalid_y


gravedad:

	ld a, e_jump(ix)
	cp #-1
	jp nz, valid_y
	ld e_jump(ix), #16;Indice de la taba donde comienza el descenso
	jp valid_y


invalid_y_down:
	ld a, #0
	ld e_vy(ix), a
	ld e_jump(ix), #-1
	jp endif_y



vx_negativa:

	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld  b, a

	;push bc

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w
	
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, invalid_x

	;pop bc
	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #8
	ld  b, a

	;ld  a, b
	;ld  b, a
	;push bc

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w

	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, invalid_x

	;pop bc
	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #15
	ld  b, a

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w

	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jp   nz, invalid_x


	jr valid_x

vx_positiva:
	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #3
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld  b, a

	;push bc

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w
	
	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jr   nz, invalid_x

	;pop bc
	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #3
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #8
	ld  b, a

	;ld  a, b
	;ld  b, a
	;push bc

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w

	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jr   nz, invalid_x

	;pop bc
	ld  a, e_x(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vx(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #3
	ld  c, a

	ld  a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	add #15
	ld  b, a

	ld    de, #0xC000
	call cpct_getScreenPtr_asm; x, y+w

	ld    a, (hl)
	cp   #0x03  ;;Mis tiles de color de fondo
	jr   nz, invalid_x

	jr valid_x

sys_physics_update::
	
_ent_array_ptr_physics = .+2

	ld ix, #0x0000 ;; La instruccion ocupa 4 bytes, 2 para ld ix y 2 para #0x0000

	bit 7, e_vx(ix)
	jp nz, vx_negativa
	jr vx_positiva


_update_loop:

	ld a, e_w(ix) ;; Cargo en A el estado de ia de la entidad
	cp #e_w_invalidEntity
	ret z

	
valid_x:
	ld  a, e_x(ix) ;; Cargo en a la posicion x --> A = e.x
	add e_vx(ix) ;; Sumo la velocidad de x a la posicion de x --> e.x += e.vx
	
	ld e_x(ix), a ;; Almaceno la nueva posicion --> e.x = a
	jr endif_x ;; Salto a endif_x y se queda actualizada

invalid_x:

	ld a, e_vx(ix) ;; Cargo en a la velociad de x --> A = e.vx
	neg ;; Cambio el signo de la velocidad --> e.vx = -e.vx
	ld e_vx(ix), a ;; Almaceno en e.vx la nueva velocidad

endif_x:
	
	ld a, e_ai_st(ix)
	;; #e_ai_st_noAI --> Al ser un valor inmediato se accede con #
	cp #e_ai_st_noAI
	jr z, _hero  ;; Comparo los valores A con e_ai_st_noAI --> Si son iguales quiere decir que no tiene IA y no debe actualizarla
	;Comprobamos si la vy es negativa o positiva (CON EL FIN DE SOLO COMPROBAR SU BOUNDING BOX SUPERIOR O INFERIOR) 
	jr valid_y

_hero:
	ld a, e_vy(ix)
	cp #0
	jp z, vyNeutra
	bit 7, e_vy(ix)
	jp z, vy_positiva
	jp vy_negativa

valid_y:

	ld a, e_y(ix) ;; Cargo en a la posicion y --> A = e.y
	add e_vy(ix) ;; Sumo la velocidad de y a la posicion de y --> e.y += e.vy
	ld e_y(ix), a ;; Almaceno la nueva posicion --> e.y = a
	jr endif_y ;; Salto a endif_y y se queda actualizada

invalid_y:
	ld a, e_vy(ix) ;; Cargo en a la velociad de y --> A = e.vy
	neg ;; Cambio el signo de la velocidad --> e.vy = -e.vy
	ld e_vy(ix), a ;; Almaceno en e.vy la nueva velocidad

endif_y:

	ld de, #sizeof_e
	add ix, de;Siguinte entidad
	jp _update_loop ;; Actualizo la siguiente entidad
